VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CStreamProcess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type FilterTag
    strName As String
    strStart As String
    strEnd As String
    strFilterValues() As String
End Type

Private m_FilterTags() As FilterTag

Private Const T_OPEN = "<"
Private Const T_CLOSE = ">"
Private Const T_QUOTES = """'"
Private Const S_CUT = "<!-- cut by VBMimeFilterSample -->"
Private Const lS_CUT = 12

Private strBuffer As String
Private tmpBuffer As String

Private t_Buff As String
Private lLen As Long, lPtr As Long, lStart As Long, lEnd As Long

Private m_bDone As Boolean
Private m_bProcessingEnabled As Boolean
Private m_bTmpBufferUsed As Boolean

Private log As CLogger

Private Function BlockCheck(blType As Long) As Boolean
Dim i As Long, s As String
    s = Mid$(t_Buff, lStart, lEnd - lStart)

    For i = 0 To UBound(m_FilterTags(blType).strFilterValues)
        If InStr(1, s, m_FilterTags(blType).strFilterValues(i), vbTextCompare) > 0 Then

            log.log vbCrLf & "S:" & lStart & " E:" & lEnd & " L:" & lEnd - lStart
            log.log vbCrLf & "|" & s & "|" & vbCrLf
            log.log "Match: " & m_FilterTags(blType).strFilterValues(i)

            BlockCheck = True
            Exit Function
        End If
    Next i

    BlockCheck = False
End Function

Private Sub Class_Initialize()
    m_bDone = False
    m_bProcessingEnabled = True

    ReDim m_FilterTags(1)

    m_FilterTags(0).strName = "script"
    m_FilterTags(0).strStart = "<script "
    m_FilterTags(0).strEnd = "</script>"
    ReDim m_FilterTags(0).strFilterValues(0)
    m_FilterTags(0).strFilterValues(0) = "http://1traff.ru/script/js.php"
    '    'http://city-film.ru/',    .  ,
    '      -       (<!-- cut by... -->)

    m_FilterTags(1).strName = "img"
    m_FilterTags(1).strStart = "<img "
    m_FilterTags(1).strEnd = ""
    ReDim m_FilterTags(1).strFilterValues(0)
    m_FilterTags(1).strFilterValues(0) = "http://imgl.yandex.net/i/www/logo1.png"
    '    'http://www.yandex.ru'

    Set log = New CLogger
    log.FileName = "C:\VBMimeFilterSample.log"
    log.FixTime = False
End Sub

Private Sub Class_Terminate()

    Set log = Nothing
End Sub

Private Sub ClearBlock()
    t_Buff = Left$(t_Buff, lStart - 1) & S_CUT & Mid$(t_Buff, lEnd)
    lPtr = lStart + Len(S_CUT)
    lLen = Len(t_Buff)
End Sub

Private Function GetFilterTagType()
Dim i As Long, l As Long, tl As Long
    tl = lLen - lPtr
    GetFilterTagType = -2
    For i = 0 To UBound(m_FilterTags)
        l = Len(m_FilterTags(i).strStart)
        If tl < l Then
            'too small buffer -> store to tmp
            GetFilterTagType = -1
            Exit Function
        End If

        If StrComp(m_FilterTags(i).strStart, Mid$(t_Buff, lPtr, l), vbTextCompare) = 0 Then
            'FilterTag found! FilterTag type = i
            GetFilterTagType = i
            Exit Function
        End If
    Next i
End Function

Private Function SearchBlockEnd(b_FilterTag As FilterTag) As Boolean
Dim l As Long, i As Long, s As String
    l = Len(b_FilterTag.strEnd)
    If l > 0 Then
        lPtr = lPtr + Len(b_FilterTag.strStart)
        lPtr = FindFilterTag(b_FilterTag.strEnd)
        If lPtr > 0 Then
            'find FilterTag end
            lPtr = lPtr + l
            lEnd = lPtr
            SearchBlockEnd = True
            Exit Function
        Else
            'end not found
            SearchBlockEnd = False
            Exit Function
        End If
    Else
        'search tag end
        For i = lPtr To lLen
            s = Mid$(t_Buff, i, 1)
            If s = T_CLOSE Then
                lPtr = i + 1
                lEnd = lPtr
                SearchBlockEnd = True
                Exit Function
            End If
            If InStr(T_QUOTES, s) > 0 Then
                i = InStr(i + 1, t_Buff, s, vbTextCompare)
                If i = 0 Then
                    'q2 not found
                    SearchBlockEnd = False
                    Exit Function
                End If
            End If
        Next i
    End If
End Function

Private Function TMPPop(sNewBuffer As String) As Long
    If m_bTmpBufferUsed Then
        t_Buff = tmpBuffer & sNewBuffer
        tmpBuffer = ""
        m_bTmpBufferUsed = False
    Else
        t_Buff = sNewBuffer
    End If
    lLen = Len(t_Buff)
    lPtr = 1
End Function

Private Function FindFilterTag(Optional T_FIND As String = T_OPEN) As Long
    If Len(T_FIND) > 0 Then
        FindFilterTag = InStr(lPtr, t_Buff, T_FIND, vbTextCompare)
    Else
        FindFilterTag = 0
    End If
End Function

Private Function TMPPush() As Long
    tmpBuffer = Mid$(t_Buff, lStart)
    t_Buff = Left$(t_Buff, lStart - 1)
    m_bTmpBufferUsed = True
End Function

Private Function ProcessBuff(sBuffer As String) As String
Dim tt As Long, tk As FilterTag
    TMPPop sBuffer

    'find next tag:
    lPtr = FindFilterTag
    Do While lPtr > 0
        't_open found. Check t_type
        lStart = lPtr
        tt = GetFilterTagType()
        Select Case tt
            Case -1
                'buffer too small to test -> store to tmp
                TMPPush
                Exit Do
            Case -2
                'no FilterTag -> search next FilterTag
                'increase pointer
                lPtr = lPtr + 1
            Case Else
                'FilterTag found! Search FilterTag end
                lStart = lPtr
                tk = m_FilterTags(tt)
                'log.log vbCrLf & "FilterTag '" & tk.strName & "' start found at:" & lStart

                If SearchBlockEnd(tk) Then
                    'block end found! Test block
                    'log.log "FilterTag '" & tk.strName & "' end found at:" & lEnd
                    If BlockCheck(tt) Then
                        ClearBlock
                    End If
                Else
                    'end not found:
                    TMPPush
                    Exit Do
                End If
        End Select

        'next tag:
        lPtr = FindFilterTag
    Loop

    ProcessBuff = t_Buff
End Function

Public Function Add(strNewBuff As String) As Long
    strBuffer = strBuffer & IIf(m_bProcessingEnabled, ProcessBuff(strNewBuff), strNewBuff)
    'strBuffer = strBuffer & strNewBuff
    'log.log strNewBuff
End Function

Public Sub Done()
    m_bDone = True
End Sub

Public Function IsDone() As Boolean
    IsDone = m_bDone
End Function

Public Function Read(ByVal pv As Long, ByVal cb As Long, pcbRead As Long) As Long
Dim l As Long, tmpByteArray() As Byte
    l = Len(strBuffer)

    If l > 0 Then
        pcbRead = IIf(cb > l, l, cb)
        ReDim tmpByteArray(pcbRead - 1)
        tmpByteArray = StrConv(Left$(strBuffer, pcbRead), vbFromUnicode)
        CopyMemory pv, VarPtr(tmpByteArray(0)), pcbRead
        Read = S_OK
        
        strBuffer = Mid$(strBuffer, pcbRead + 1)
        l = Len(strBuffer)
    End If

    If l = 0 Then
        If m_bDone Then
            'no more data
            Read = S_FALSE
        Else
            'data pending
            Read = E_PENDING
        End If
        Exit Function
    End If
End Function
