VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBMimeFilterSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements olelib2.IInternetProtocol
Implements olelib2.IInternetProtocolSink

Private m_IncomingProt     As olelib.IInternetProtocol
Private m_OutgoingProtSink  As olelib2.IInternetProtocolSink

Private Const MAX_READ_SIZE As Long = 8192

Private m_Stream As CStreamProcess

Private Sub Class_Initialize()
Dim oPH As olelib2.IInternetProtocol

    ' Get the IInternetProtocol interface
    Set oPH = Me
    
    ' Replace the Read method
    ReplaceVTableEntry ObjPtr(oPH), 10, AddressOf mdlProtocolHandler.IInternetProtocol_Read

    Set m_Stream = New CStreamProcess
End Sub

Private Sub Class_Terminate()
    Set m_Stream = Nothing
    If Not m_IncomingProt Is Nothing Then Set m_IncomingProt = Nothing
End Sub

Private Sub IInternetProtocol_Read(ByVal pv As Long, ByVal cb As Long, pcbRead As Long)
   ' This member is replaced with the function in the .bas module
End Sub

Friend Function Read(ByVal pv As Long, ByVal cb As Long, pcbRead As Long) As Long
    'Err.Raise E_NOTIMPL
    'Exit Function
    
    'Read = Read_direct(pv, cb, pcbRead)     '    "" 
    Read = Read_process(pv, cb, pcbRead)    '  CStreamProcess, ..
End Function

Friend Function Read_direct(ByVal pv As Long, ByVal cb As Long, pcbRead As Long) As Long
    Dim hr As Long
    
    hr = m_IncomingProt.Read(pv, cb, pcbRead)
    Read_direct = hr
End Function

Friend Function Read_process(ByVal pv As Long, ByVal cb As Long, pcbRead As Long) As Long
    Dim hr As Long
    Dim cbRead As Long
    Dim byteReadBuffer() As Byte
    Dim s As String

    If Not m_Stream.IsDone Then
        'read new portion of data
        ReDim byteReadBuffer(MAX_READ_SIZE - 1)
        hr = m_IncomingProt.Read(VarPtr(byteReadBuffer(0)), MAX_READ_SIZE, cbRead)

        If cbRead > 0 Then
            m_Stream.Add Left$(StrConv(byteReadBuffer, vbUnicode), cbRead)
        End If
        
        If hr = S_FALSE Then
            m_Stream.Done
        End If

        If hr < 0 And hr <> E_PENDING Then
            Read_process = hr
            Exit Function
        End If
    End If

    Read_process = m_Stream.Read(pv, cb, pcbRead)
End Function

Private Sub IInternetProtocol_Start(ByVal szUrl As Long, ByVal pOIProtSink As olelib2.IInternetProtocolSink, ByVal pOIBindInfo As olelib.IInternetBindInfo, ByVal grfPI As olelib.PI_FLAGS, dwReserved As olelib.PROTOCOLFILTERDATA)
    If Not CBool(grfPI And PI_FILTER_MODE) Then
        Err.Raise E_INVALIDARG
    Else
        If dwReserved.pProtocol Is Nothing Then
            Err.Raise E_INVALIDARG
        Else
            Set m_IncomingProt = dwReserved.pProtocol
        End If
    End If

    Set m_OutgoingProtSink = pOIProtSink
End Sub

Private Sub IInternetProtocol_Continue(pProtocolData As olelib.PROTOCOLDATA)
    If m_IncomingProt Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_IncomingProt.Continue pProtocolData
End Sub

Private Sub IInternetProtocol_Abort(ByVal hrReason As Long, ByVal dwOptions As Long)
    If m_IncomingProt Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_IncomingProt.Abort hrReason, dwOptions
End Sub

Private Sub IInternetProtocol_Terminate(ByVal dwOptions As Long)
    Set m_OutgoingProtSink = Nothing

    If m_IncomingProt Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_IncomingProt.Terminate dwOptions
End Sub

Private Sub IInternetProtocol_Suspend()
    If m_IncomingProt Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_IncomingProt.Suspend
End Sub

Private Sub IInternetProtocol_Resume()
    If m_IncomingProt Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_IncomingProt.Resume
End Sub

Private Sub IInternetProtocol_Seek(ByVal dlibMove As Currency, ByVal dwOrigin As Long, plibNewPosition As Currency)
    Err.Raise E_NOTIMPL
End Sub

Private Sub IInternetProtocol_LockRequest(ByVal dwOptions As Long)
    'return 0 (S_OK)
End Sub

Private Sub IInternetProtocol_UnlockRequest()
    'return 0 (S_OK)
End Sub

Private Sub IInternetProtocolSink_Switch(pProtocolData As olelib.PROTOCOLDATA)
    If m_OutgoingProtSink Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_OutgoingProtSink.Switch pProtocolData
End Sub

Private Sub IInternetProtocolSink_ReportProgress(ByVal ulStatusCode As olelib.BINDSTATUS, ByVal szStatusText As Long)
    If m_OutgoingProtSink Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_OutgoingProtSink.ReportProgress ulStatusCode, szStatusText
End Sub

Private Sub IInternetProtocolSink_ReportData(ByVal grfBSCF As olelib.BSCF, ByVal ulProgress As Long, ByVal ulProgressMax As Long)
    If m_OutgoingProtSink Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_OutgoingProtSink.ReportData grfBSCF, ulProgress, ulProgressMax
End Sub

Private Sub IInternetProtocolSink_ReportResult(ByVal hrResult As Long, ByVal dwError As Long, ByVal szResult As Long)
    If m_OutgoingProtSink Is Nothing Then Err.Raise E_FAIL: Exit Sub

    m_OutgoingProtSink.ReportResult hrResult, dwError, szResult
End Sub
